import re
import sys
from ftplib import FTP

def usage():
    s="Usage:"
    s+="%s flag isControlFT isRename STBIP curStep passWord Path\n"%sys.argv[0]
    s+="\t flag: 0:stb->pc 1:pc->stb\n"
    s+="\t isControlFT: true OR false\n"
    s+="\t isRename: 0:pc->stb ProcessLog.txt 1:stb->pc ProcessLog2.txt\n"
    s+="\t stbip: stb's ipaddress\n"
    s+="\t curStep: curStep\n"
    s+="\t passWord: passWord\n"
    s+="\t Path: ProcessLog.txt's local path\n"
    print s.decode('utf-8').encode('gbk')
        
def isIP(ip):
    m=re.match('^(\d+)\.(\d+).(\d+).(\d+)$',ip.strip())
    if m:
        isOK=True
        for i in range(1,5):
            ip=int(m.group(i))
            if ip>255:
               isOK=False
               break
        return isOK
    else:
        return False       
    
if len(sys.argv)<8:
   usage()
   sys.exit(-1)
        
try:    
    flag=int(sys.argv[1])
except:
    print "flag expect a 0 or 1,you input %s"%sys.argv[1]
    print "Unexpected error:", sys.exc_info()[0]
    sys.exit(-1)
if flag<0 or flag>1:
    print "flag expect a 0 or 1,you input %s"%sys.argv[1]
    sys.exit(-1)    
        
isControlFT=sys.argv[2].lower()
if isControlFT not in ['true','false']:
    print "isControlFT should be in true or false,you input %s"%sys.argv[2]
    sys.exit(-1)
    
try:    
    isRename=int(sys.argv[3])
except:
    print "isRename expect a 0 or 1,you input %s"%sys.argv[3]
    print "Unexpected error:", sys.exc_info()[0]
    sys.exit(-1)
if isRename<0 or isRename>1:
    print "isRename expect a 0 or 1,you input %s"%sys.argv[3]
    sys.exit(-1) 
        
stbip=sys.argv[4]
if not isIP(stbip):
    print "stbip should be a valid ip,you input %s"%sys.argv[4]
    sys.exit(-1)
    
try:    
    curStep=int(sys.argv[5])
except:
    print "curStep should be a int,you input %s"%curStep
    
passWord=sys.argv[6]

Path=sys.argv[7]
    
def handleDownload(block):
    file.write(block)
    print ".",
    
ftp = FTP(stbip,'root', passWord)

print 'Welcome to Matt\'s ftplib example'
print 'Logging in.'

directory = '/mnt/data'
print 'Changing to ' + directory
ftp.cwd(directory)

if flag==1:
    if isRename==0:
        #pc's ProcessLog.txt-->/mnt/data
        filename = Path + '\ProcessLog.txt'
        filename1 = 'ProcessLog.txt'

        print 'Opening local file ' + filename
        try:
            file=open(filename,"rb")
        except Exception,e:
            print e

        print 'Putting ' + filename
        ftp.storbinary('stor ' + filename1,file) 
    else:
        #/mnt/data's ProcessLog2.txt-->PC
        filename = 'ProcessLog2.txt'
        filename1 = Path + '\ProcessLog2.txt'

        print 'Opening local file ' + filename
        try:
            #file=open(filename,"wb")
            file=open(filename1,"wb")
        except Exception,e:
            print e
            
        print 'Getting ' + filename
        ftp.retrbinary('RETR ' + filename, handleDownload)
else:
    if curStep==1:
         if isControlFT=='true':
            #/mnt/data's boardtestlog.txt and testresult.txt-->pc
            filename = 'boardtestlog.txt'
            #filename1 = Path + '\boardtestlog.txt'

            print 'Opening local file ' + filename
            try:
                file=open(filename,"wb")
                #file=open(filename1,"wb")
            except Exception,e:
                print e
            
            print 'Getting ' + filename
            ftp.retrbinary('RETR ' + filename, handleDownload)
            
            
                        #print 'Closing file ' + filename
                        #file.close()
            
            filename = 'testresult.txt'
            #filename1 = Path + '\testresult.txt'

            print 'Opening local file ' + filename
            try:
                file=open(filename,"wb")
                #file=open(filename1,"wb")
            except Exception,e:
                print e
            
            print 'Getting ' + filename
            ftp.retrbinary('RETR ' + filename, handleDownload)
 
         #/mnt/data's ProcessLog.txt-->pc
    filename = 'ProcessLog.txt'
    filename1 = Path + '\ProcessLog.txt'

    print 'Opening local file ' + filename
    try:
        file=open(filename1,"wb")
    except Exception,e:
        print e
            
    print 'Getting ' + filename
    ftp.retrbinary('RETR ' + filename, handleDownload)

print 'Closing file ' + filename
file.close()

print 'Closing FTP connection'
print ftp.close()

sys.exit(0)